/*-----------------------------------------------------------------------
	Warp-GGI

	General Graphics Interface demo
	Realtime picture 'gooing'

	readpcx.c : PCX files reader	

        PCX original code by some cow-orker i forgot :)
        Adapted and way optimized by Emmanuel Marty <emarty@mirus.fr>

	Feel free to reuse this for other GGI demos and projects.

	Released under GNU Public License
-----------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include <ggi/libggi.h>
#include "rawpict.h"

struct pcx_header {
	char       manufacturer;
	char       version;
	char       encoding;
	char       bits_per_pixel;
	ushort     xmin,ymin;
	ushort     xmax,ymax;
	ushort     hres;
	ushort     vres;

	char       palette16[48];
	char       reserved;
	char       color_planes;
	ushort     bytes_per_line;
	ushort     palette_type;
	char       filler [58];
};

int readPCX (char *name, struct raw_pict *rp)
{
	FILE			*f;
	unsigned short		bytes;
	struct	pcx_header	header;
	unsigned int		i, j, c, err;
	unsigned int		width, height;
	ggi_color		*palette;
	char			*fbuf, *lptr, *nextlptr, palbuf[4];

	err = 0;

	if ( (f = fopen(name,"rb")) ) {
		fread ( (char*) &header, 1, sizeof (struct pcx_header), f);

		width  = header.xmax - header.xmin + 1;
		height = header.ymax - header.ymin + 1;
		bytes  = header.bytes_per_line;

		rp->width  = width;
		rp->height = height;
		rp->depth = 8;

		if ( (fbuf = (char *) malloc (width * height)) ) {
			rp->framebuf = (void *) fbuf;
			lptr = fbuf;

			for (i=0; i<height; ++i) {
				nextlptr = lptr + width;

				do {
					c = fgetc (f) & 0xFF;
					if ( (c & 0xC0) == 0xC0) {
						j = c & 0x3F;
						c = fgetc (f);
						while (j--)
							*lptr++ = c;
	    				}
	    				else *lptr++ = c;
	   			} while ( lptr < nextlptr);

				lptr = nextlptr;
	  		}

	  		if ( fgetc (f) == 12 ) {
				if ( (palette = (ggi_color *)
				      malloc (256 * sizeof(ggi_color))) ) {

					for (i = 0; i < 256; i++) {
						fread (palbuf, 1, 3, f);
						palette[i].r = palbuf[0] << 8;
						palette[i].g = palbuf[1] << 8;
						palette[i].b = palbuf[2] << 8;
					}
					rp->clut = palette;
				}
				else err = RPREAD_NOMEM;
	  		}
			else rp->clut = NULL;

			if (err) free (fbuf);
	 	}
		else err = RPREAD_NOMEM;

	 	fclose (f);
    	}
	else err = RPREAD_NOFILE;

	return (err);
}
